/*

Copyright 2005-2006, Shawn Platkus
PlatkusWorld Software
*/

// Global variables used throughout the JavaScript functions

 var gWidth = 0;
 var gHeight = 0;
 var gPrefsWidth = 350;
 var gPrefsHeight = 400;
 var gMaxWidth = 1000;
 var gMaxHeight = 1000;
 var gMinWidth = 180;
 var gMinHeight = 100;
 var gFrontWidth;
 var gFrontHeight;
 
 var intRefresh = 0;
 var timerInterval = null;
 var imageNumber = 0;	// Trick the caching mechanism into reloading our pic
 var playHead = -1;		// The position of the playHead
 var playMode = 1;		// Forward or Reverse through the cached images
 var picturesrc;		// The source of the image
 var bOnBack = false;	// Are the preferences showing
 var bResizing = false;	// Is the Window currentl being resized
 var bResized = false;	// Has the Window been resized
 var bAutoMinimize = false;	// Is Auto Minimizing turned on
 var bMinimize = false;		// Is it OK to perform the Auto Minimization
 var delayAutoMinimize = 2222;	// The delay in miliseconds before Auto Minimizing
 var bAutoMaximize = false;	// Is Auto Maximizing Turned On
 var bMaximized = false;	// Is the Window Maximized
 var bMinMaxSemaphore = false;	// Min or Max in progress
 var bMaintainProportion = true;	// Maintain image proportion while resizing

// Resizes the "picture" and widget window when a new picture is added.

function imageResize(x,y)
{
	if(x > gMaxWidth) {			// the maximum image width is gMaxWidth pixels, so if the image
//		y = y * (gMaxWidth/x);	// is larger, we need to scale it down
		x = gMaxWidth;
	}

	if(y > gMaxHeight) {			// the maximum image height is gMaxHeight pixels
//		x = x * (gMaxHeight/y);
		y = gMaxHeight;
	}

	if(x < 180) {			// the minimum image width is 180px, so if the image
//		y = y * (180/x);	// is smaller, then it needs to be scaled up
		x = 180;
	}

	if(y < 100) {			// the minimum image height is 100px
//		x = x * (100/y);
		y = 100;
	}

//	document.picture.width = x;		// once the dimensions are determined, the
	document.getElementById("picture").width = x;		// once the dimensions are determined, the
//	document.picture.height = y;	// "picture" <img> is sized accordingly
	document.getElementById("picture").height = y;	// "picture" <img> is sized accordingly

	frameResize(x+52, y+52);		// the frame and mat are 52px, so adjust window
}


function frameResize(x,y)
{
	gHeight = y;					// the frame and mat are 52px, so the widget window
	gWidth = x;						// needs to be 52px larger than the image
	
	if(window.widget) 								// you check to see if the widget is
	{												// running in Dashboard, and then
		window.resizeTo(gWidth, gHeight);			// resize the widget window
	}
	
	dndindicator.style.left = ( (gWidth/2) - 103 );	// the drag and drop indicator needs
	dndindicator.style.bottom = 30;					// to be repositioned as well.  It's
													// located at the bottom middle.

	// Setup the Playback Indicator
	playbackIndicator.style.left = (gWidth - 67);
	playbackIndicator.style.top = 40;


	// Setup the Play Controls
	playControl.style.left = ((gWidth/2) - 15);
	playControl.style.bottom = 55;

	pauseControl.style.left = ((gWidth/2) - 15);
	pauseControl.style.bottom = 55;

	reverseControl.style.left = ((gWidth/2) - 103);
	reverseControl.style.bottom = 55;

	forwardControl.style.left = ((gWidth/2) + 73);
	forwardControl.style.bottom = 55;
}


// The resize event handler function.

function preResize()
{
	// calls the resize function with the size of the new picture
	if (bResized)
	{
		imageResize(parseInt(document.getElementById("picture").width), parseInt(document.getElementById("picture").height));
	}
	else
	{
		imageResize(parseInt(document.getElementById("hiddenPic").width), parseInt(document.getElementById("hiddenPic").height));
	}
}


//	resizeBackPrefs - This function resizes the back preference elements given 
//						a width and height

function resizeBackPrefs(width, height)
{
	back.style.height = height - 4;			// the preferences layer is resized
	back.style.width = width - 6;			// to fit the new dimensions

	hanger.style.left = ( (width/2) - 50 );			// when the widget is resized,
	framePopup.style.left = ( (width/2) - 50 );		// various preference elements
	frameText.style.left = ( (width/2) - 92); 		// need to be repositioned
	matPopup.style.left = ( (width/2) - 50 );
	matText.style.left = ( (width/2) - 80); 
	refreshPopup.style.left = ( (width/2) - 50 );
	refreshText.style.left = ( (width/2) - 124); 
	doneButton.style.left = ( (width/2) - 29);
}


// Since this widget allows for multiple instances of itself, each needs
// to retain its own preferences.  Dashboard provides each widget with a 
// unique identifier that persists between logins.  This wrapper provides
// a property tied with the unique identifier.

function makeKey(key)
{
	return widget.identifier + "-" + key;
}


// The preference arrow that appears at the bottom-right of the mat may be white
// or black, depending on the mat color.  This function is a wrapper that adjusts
// the image to what it should be, and records the preference.

function prefArrowColor(color)
{
	if(color == "white")
	{
		prefButton.src= "/System/Library/WidgetResources/ibutton/white_i.png";
		prefButtonHighlight.src="/System/Library/WidgetResources/ibutton/white_rollie.png";
	}
	else {
		prefButton.src= "/System/Library/WidgetResources/ibutton/black_i.png";
		prefButtonHighlight.src="/System/Library/WidgetResources/ibutton/black_rollie.png";
	}
}


// The setup function is called upon the loading of the widget.  It initializes
// the various elements of the widget if they have preferences.  If not, the default
// settings are used.

function setup()
{
	if(window.widget)
	{
		// The frame preferences are retrieved:
		var frameColor = widget.preferenceForKey(makeKey("frameColor"));
		setFrameColor(frameColor);
		
		// The mat preferences are retrieved:
		var matColor = widget.preferenceForKey(makeKey("matColor"));
		setMatColor(matColor);

		// The refresh interval preference is retrieved:
		intRefresh = widget.preferenceForKey(makeKey("refreshInt"));
		refreshTimer(true);

		// The Auto Minimize Preference is retrieved
		bAutoMinimize = widget.preferenceForKey(makeKey("autoMinimize"));

		// The image preferences are retrieved:
		picturesrc = widget.preferenceForKey(makeKey("image"));
		
		if (picturesrc && picturesrc.length > 0)			// if there was a preference
		{													// for this instance, it is
			var img, img2;									// assigned to the "picture"
			img = document.getElementById ("picture");		// and the "hiddenPic" (used
			img2 = document.getElementById ("hiddenPic");	// to ascertain image dimensions).
			img.src = img2.src = picturesrc;				// A load handler is assigned
			img.onload = preResize;							// for when the image has loaded
		}
		else												// if no preference was found
		{													// the widget should be sized
			preResize();									// for the default image
		}

		// The custom image size preferences are retrieved
		var x, y;
		x = widget.preferenceForKey(makeKey("customWidth"));
		y = widget.preferenceForKey(makeKey("customHeight"));
		if (x && y)
		{
			bResized = true;
			imageResize(x,y);
		}

		// The Auto Maximize Preference is retrieved
		bAutoMaximize = widget.preferenceForKey(makeKey("autoMaximize"));

		// The Maintain Proportion Preference is retrieved
		bMaintainProportion = widget.preferenceForKey(makeKey("maintainProportion"));
		if (bMaintainProportion == null)
		{
			bMaintainProportion = true;		// Default to true
		}

		resizeBackPrefs(gPrefsWidth, gPrefsHeight);			// Resize the Back Prefs to a fixed size
		setupBackPrefs();									// Set the controls up on the back
	}
}


//	setupBackPrefs - Sets the controls on the back of the widgets to match the stored preferences
function setupBackPrefs ()
{
	// Set the Popup controls to the correct value based on the Prefs
	if(window.widget)
	{
		intRefresh = widget.preferenceForKey(makeKey("refreshInt"));
		var matColor = widget.preferenceForKey(makeKey("matColor"));
		var frameColor = widget.preferenceForKey(makeKey("frameColor"));
		setPrefPopup("refreshPopup", intRefresh);
		setPrefPopup("matPopup", matColor);
		setPrefPopup("framePopup", frameColor);

        document.getElementById("autoMinimizeCheckbox").checked = bAutoMinimize;

        document.getElementById("autoMaximizeCheckbox").checked = bAutoMaximize;

        document.getElementById("maintainProportionCheckbox").checked = bMaintainProportion;
	}
}


// The event handler for the image drop.  This handles fetching the image URL and trying
// to place it inside of the widget.

function dragdrop (event)
{
	var uri = null;
	try {
	    uri = event.dataTransfer.getData("text/uri-list");	// attempt to load the new
	} catch (ex)											// image
	{
	}
	
	//alert(uri);		// For debugging in Safari
	
	// if the acquisition is successful:
	if (uri)
	{
		if(window.widget)
		{
			widget.setPreferenceForKey(uri,makeKey("image"));	// set the preference for
		}														// the new image

		bResized = false;			// Let the new picture take its actual size
		clearCustomImageSize();

		picturesrc = uri;

		var img, img2;
		img = document.getElementById ("picture");				// then, assign the new
		img2 = document.getElementById ("hiddenPic");			// image to the "picture"
		img.src = img2.src = uri;								// and the "hiddenPic"; a
		img.onload = preResize;									// load handler is called
	}															// when the image has loaded

	event.stopPropagation();
	event.preventDefault();
}


// The dragenter, dragover, and dragleave functions are implemented but not used.  They
// can be used if you want to change the image when it enters the widget.

function dragenter (event)
{
	event.stopPropagation();
	event.preventDefault();
}

function dragover (event)
{
	event.stopPropagation();
	event.preventDefault();
}

function dragleave (event)
{
	event.stopPropagation();
	event.preventDefault();
}


// The showPrefs function is called when the preferences button is clicked.  It prepares
// the widget to show the preferences, and then flips them.

function showPrefs()
{
	// Set the Preferences Boolean State
	bOnBack = true;

	// Wait for Animated resizings to stop and then flag it as in use
	if (isMinMax())
		return;

	setMinMaxSemaphore();

	// Stop the Refresh Timer
	refreshTimer(false);
	
	// store the front height and width values to restore on return to front
	gFrontHeight = gHeight;
	gFrontWidth = gWidth;

	// Two AppleRect objects store the starting and finshing rectangle sizes
	var startingRect = new AppleRect (0, 0, gFrontWidth, gFrontHeight);
	var finishingRect = new AppleRect (0, 0, gPrefsWidth, gPrefsHeight);
	
	// The RectAnimation specifies the range of values and the handler to call at the animator's interval
	var currentRectAnimation = new AppleRectAnimation( startingRect, finishingRect, rectHandler );

	// The Animator is the timer for the animation
	var currentAnimator = new AppleAnimator (500, 13);
	
	// Associate the animator and animation
	currentAnimator.addAnimation(currentRectAnimation);
	
	// Set a handler to be called when the animation is done (in this case, flip the widget to its back)
	currentAnimator.oncomplete = flipToBack;
	
	// Once everything is set up, start the animation
	currentAnimator.start();
	
}


function flipToBack()
{
	var front = document.getElementById("front");		// first, you need to get the front
	var back = document.getElementById("back");			// and back layers

	if(window.widget)									// this freezes the currently visible
		widget.prepareForTransition("ToBack");			// layer
	
	front.style.display="none";							// the preferences layer is made
	back.style.display="block";							// visible and the picture is hidden
				
	if(window.widget)									// the flip transition is run, with the
		setTimeout ('widget.performTransition();', 0);	// frozen side on the front and the
														// preferences on the back

	document.getElementById("prefButtonHighlight").style.display='none';
}


// When the "Done" button is clicked in the preferences, this function is called. It swaps
// the preference layer out with the picture and frame.

function hidePrefs()
{
	document.getElementById("doneButton").src = "Images/done.png";  // restore the regular
																	// "Done" button

	var front = document.getElementById("front");		// again, you need to obtain the front
	var back = document.getElementById("back");			// and back layers
	
	if (window.widget)									// then freeze the visible layer (as seen
		widget.prepareForTransition("ToFront");			// by the user
	
	front.style.display="block";						// hide the preferences layer and show the 
	back.style.display="none";							// main picture layer
	
	if (window.widget)									// and run the flip transition; note that since
		setTimeout ('widget.performTransition();', 0);	// finishEdit() was used to freeze the UI, this 
														// the widget in the opposite direction
	
	// Once the flip to the front is complete, flipToFront resizes the widget back to its former size.
	setTimeout("flipToFront()", 750);

	// Set the Preferences Boolean State
	bOnBack = false;

	// Reset Auto Min and Max preferences
	setMaintainProportion();
	setTimeout ('setAutoMinimize();', delayAutoMinimize);
	setTimeout ('setAutoMaximize();', delayAutoMinimize);
}


// flipToFront uses another AppleRectAnimation to resize the widget to its previous size

function flipToFront()
{
	var startingRect = new AppleRect (0, 0, gPrefsWidth, gPrefsHeight);
	var finishingRect = new AppleRect (0, 0, gFrontWidth, gFrontHeight);

	var currentRectAnimation = new AppleRectAnimation( startingRect, finishingRect, rectHandler );

	var currentAnimator = new AppleAnimator (500, 13);
	currentAnimator.addAnimation(currentRectAnimation);
	currentAnimator.start();	

	// Start the Refresh Timer
	refreshTimer(true);

	// Clear the flag for normal operation again
	clearMinMaxSemaphore();
}


// The rectHandler is called each interval by the Animator.  It passes in the animation values at
// this point in the animation.  The values are used to resize parts of the interface and the
// widget as a whole

function rectHandler( rectAnimation, currentRect, startingRect, finishingRect )
{
	frameResize(currentRect.right, currentRect.bottom);
}


// The rectHandler is called each interval by the Animator.  It passes in the animation values at
// this point in the animation.  The values are used to resize parts of the interface and the
// widget as a whole

function rectHandler2( rectAnimation, currentRect, startingRect, finishingRect )
{
	imageResize(currentRect.right, currentRect.bottom);
}


// setPrefPopup - Sets the popup control to the value specified

function setPrefPopup (elemID, theValue)
{
	var elem = document.getElementById(elemID);
	var i;	// iterator

	if (elem.options.length > 0)
	{
		for (i = 0; i < elem.options.length; i++)
		{
			if (elem.options[i].value == theValue)
			{
				elem.selectedIndex = i;
				break;
			}
		}
	}
}


// Preferences button animation
// These functions are used to animate the appearance and disappearance of the the preferences 
// button on the front side of the widget.

var flipShown = false;

// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, secondElement:null, timer:null};

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// animate() performs the fade animation for the preferences flipper and the DnD indicator. It uses the opacity CSS property.
function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
	animation.secondElement.style.opacity = animation.now;
	animation.thirdElement.style.opacity = animation.now;
}

// mousemove() is triggered whenever a mouse is moved within the bounds of your widget.  It's used
// here to prep the preference flipper fade when the mouse first enters the widget boundries.
function mousemove (event)
{
	if (!bResizing)
	{
		showPlabackControls();
		showResizerControl();
	
		if (!flipShown)
		{
			// fade in the flip widget
			if (animation.timer != null)
			{
				clearInterval (animation.timer);
				animation.timer  = null;
			}
			
			var starttime = (new Date).getTime() - 13; // set it back one frame
			
			animation.duration = 500;
			animation.starttime = starttime;
			animation.firstElement = document.getElementById ('prefButton');
			animation.secondElement = document.getElementById ('dndindicator');
			animation.thirdElement = document.getElementById ('playbackIndicator');
			animation.timer = setInterval ("animate();", 13);
			animation.from = animation.now;
			animation.to = 1.0;
			animate();
			flipShown = true;
		}
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper and DnD indicator
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion
function mouseexit (event)
{
	if (!bResizing)
	{
		hideResizerControl();
	
		hidePlabackControls();
		if (playMode == 0)
			refreshImage();			// Refresh Image in response to user interaction
	
		if (flipShown)
		{
			// fade in the flip widget
			if (animation.timer != null)
			{
				clearInterval (animation.timer);
				animation.timer  = null;
			}
			
			var starttime = (new Date).getTime() - 13; // set it back one frame
			
			animation.duration = 500;
			animation.starttime = starttime;
			animation.firstElement = document.getElementById ('prefButton');
			animation.secondElement = document.getElementById ('dndindicator');
			animation.thirdElement = document.getElementById ('playbackIndicator');
			animation.timer = setInterval ("animate();", 13);
			animation.from = animation.now;
			animation.to = 0.0;
			animate();
			flipShown = false;
		}
	startAutoMinimize();
	}

}

// mouseover() 
function mouseover (event)
{
	// Right now, we're just doing the auto minimize feature on mouse over
	undoAutoMinimize();

	doAutoMaximize();

	bMinimize = false;
}


//	Hide and Show the Pref Button Highlight

function showPrefButtonHighlight (event)
{
	document.getElementById("prefButtonHighlight").style.display="block" ;	// Make it visible
}

function hidePrefButtonHighlight (event)
{
	document.getElementById("prefButtonHighlight").style.display='none';	// Make it invisible
}


//	Hide and Show the Resizer Control

function showResizerControl()
{
	resize.style.opacity = 100;	// Make it visible
}

function hideResizerControl()
{
	resize.style.opacity = 0;	// Make it invisible
}


//	setCustomImageSize - Stores the custom Window size in the prefs

function setCustomImageSize()
{
	if (window.widget)
	{
		widget.setPreferenceForKey(parseInt(document.getElementById("picture").width), makeKey("customWidth"));
		widget.setPreferenceForKey(parseInt(document.getElementById("picture").height), makeKey("customHeight"));
	}
}

function clearCustomImageSize()
{
	if (window.widget)
	{
		widget.setPreferenceForKey(null,makeKey("customWidth"));
		widget.setPreferenceForKey(null,makeKey("customHeight"));
	}
}


// changeFrame is called by the frame popup when its value is changed.  This function
// changes the border color attributes for the frame, simulating different picture
// frame styles
function changeFrame(elem)
{
	var theColor = parseInt(elem.options[elem.selectedIndex].value);

	setFrameColor(theColor);
	
	// once the frame is changed, the new styles are saved as preferences
	if (window.widget)
	{
		widget.setPreferenceForKey(theColor, makeKey("frameColor"));
	}
}


// setFrameColor - This function changes the border color attributes for the frame,
//	simulating different picture frame styles
function setFrameColor(intColor)
{
	var frame = document.getElementById("frame");	// the frame element is obtained

	// based on the value of the popup menu, the proper frame colors are applied
	switch (intColor)
	{
		case 1: 									// black
			frame.style.borderTopColor="#030303";
			frame.style.borderRightColor="#1A1B1A";
			frame.style.borderBottomColor="#030303";
			frame.style.borderLeftColor="#1A1B1A";
			break;
		case 2:										// rosewood
			frame.style.borderTopColor="#660000";
			frame.style.borderRightColor="#8C0B04";
			frame.style.borderBottomColor="#660000";
			frame.style.borderLeftColor="#8C0B04";
			break;
		case 3:										// oak
			frame.style.borderTopColor="#A04400";
			frame.style.borderRightColor="#BB4E00";
			frame.style.borderBottomColor="#A04400";
			frame.style.borderLeftColor="#BB4E00";
			break;
		case 4:										// pine
			frame.style.borderTopColor="#C5A17F";
			frame.style.borderRightColor="#DBC0A5";
			frame.style.borderBottomColor="#C5A17F";
			frame.style.borderLeftColor="#DBC0A5";
			break;
		case 5:										// gold
			frame.style.borderTopColor="#94732A";
			frame.style.borderRightColor="#E5C062";
			frame.style.borderBottomColor="#94732A";
			frame.style.borderLeftColor="#E5C062";
			break;
		case 6:										// Azure
			frame.style.borderTopColor="#336EC9";
			frame.style.borderRightColor="#5196D1";
			frame.style.borderBottomColor="#336EC9";
			frame.style.borderLeftColor="#5196D1";
			break;
		case 7:										// Puce
			frame.style.borderTopColor="#792F46";
			frame.style.borderRightColor="#7D2B41";
			frame.style.borderBottomColor="#792F46";
			frame.style.borderLeftColor="#7D2B41";
			break;
		case 8:										// Silver
			frame.style.borderTopColor="#B6B6B6";
			frame.style.borderRightColor="#C4C4C4";
			frame.style.borderBottomColor="#B6B6B6";
			frame.style.borderLeftColor="#C4C4C4";
			break;
		case 9:										// Jade
			frame.style.borderTopColor="#0C720C";
			frame.style.borderRightColor="#148614";
			frame.style.borderBottomColor="#0C720C";
			frame.style.borderLeftColor="#148614";
			break;
		case 10:									// Indigo
			frame.style.borderTopColor="#17206D";
			frame.style.borderRightColor="#212A77";
			frame.style.borderBottomColor="#17206D";
			frame.style.borderLeftColor="#212A77";
			break;
		case 11:									// None
			frame.style.borderStyle = "none";
//			mat.style.borderWidth = 0;
			break;
	}
} 

// changeMat is called by the mat popup when its value is changed.  This function
// changes the border color attribute for the mat, simulating different mat colors
function changeMat(elem)
{	
	var theColor = parseInt(elem.options[elem.selectedIndex].value);

	setMatColor(theColor);

	// once the mat is changed, the new style is saved as a preference
	if(window.widget)
	{
		widget.setPreferenceForKey(theColor, makeKey("matColor"));
	}
}


// setMatColor - This function changes the border color attribute for the mat,
//	simulating different mat colors
function setMatColor(intColor)
{
	var mat = document.getElementById("mat");	// the mat element is obtained
	
	// based on the value of the popup menu, the proper mat color is applied.  Also,
	// the correct preference button is set here as well
	switch (intColor)
	{
		case 1:								// arctic white
			mat.style.borderColor="#F8F7F1";
			prefArrowColor("black");
			break;
		case 2:								// venetian red
			mat.style.borderColor="#9F1818";
			prefArrowColor("white");
			break;
		case 3:								// navy blue
			mat.style.borderColor="#183D89";
			prefArrowColor("white");
			break;
		case 4:								// hunter green
			mat.style.borderColor="#085B33";
			prefArrowColor("white");
			break;
		case 5:								// pumpkin orange
			mat.style.borderColor="#ED9711";
			prefArrowColor("black");
			break;
		case 6:								// royal purple
			mat.style.borderColor="#663292";
			prefArrowColor("white");
			break;
		case 7:								// sunrise yellow
			mat.style.borderColor="#EED10F";
			prefArrowColor("black");
			break;
		case 8:								// raven black
			mat.style.borderColor="#191919";
			prefArrowColor("white");
			break;
		case 9:								// metallic gray
			mat.style.borderColor="#7C7A79";
			prefArrowColor("white");
			break;
		case 10:							// cobalt blue
			mat.style.borderColor="#0F01B9";
			prefArrowColor("white");
			break;
		case 11:							// cadmium yellow
			mat.style.borderColor="#FDC001";
			prefArrowColor("black");
			break;
		case 12:							// caramel brown
			mat.style.borderColor="#BF934C";
			prefArrowColor("black");
			break;
		case 13:							// cardinal red
			mat.style.borderColor="#A41728";
			prefArrowColor("white");
			break;
		case 14:							// primrose yellow
			mat.style.borderColor="#D2D438";
			prefArrowColor("black");
			break;
	}
} 


// hidePlabackControls - Shows the correct set of controls based on the current mode
function hidePlabackControls ()
{
	reverseControl.style.opacity = 0;	// Make it invisible
	forwardControl.style.opacity = 0;	// Make it invisible
	pauseControl.style.opacity = 0;		// Make it invisible
	playControl.style.opacity = 0;		// Make it invisible
}


// showPlabackControls - Shows the correct set of controls based on the current mode
function showPlabackControls ()
{
	if (intRefresh > 0)
	{
		if (playMode == 0)
		{
			// Set Playback Indicator to Paused
			playbackIndicator.src = 'Images/indPause.png';

			if (playHead == 0)
			{
				reverseControl.style.opacity = 0;	// Make it invisible
			}
			else
			{
				reverseControl.style.opacity = 100;	// Make it visible
			}

			if (playHead == imageNumber)
			{
				forwardControl.style.opacity = 0;	// Make it invisible
			}
			else
			{
				forwardControl.style.opacity = 100;	// Make it visible
			}

			pauseControl.style.opacity = 0;			// Make it invisible
			pauseControl.style.zIndex = 18;		// Put it below play control
			playControl.style.opacity = 100;		// Make it visible
		}
		else
		{
			if (playMode == -1)
			{
				// Set Playback Indicator to Reverse
				playbackIndicator.src = 'Images/indReverse.png';
			}
			else
			{
				// Set Playback Indicator to Play
				playbackIndicator.src = 'Images/indPlay.png';
			}

			if (playMode == -1 && playHead == 0)
			{
				reverseControl.style.opacity = 0;	// Make it invisible
			}
			else
			{
				reverseControl.style.opacity = 100;	// Make it visible
			}

			if (playMode == 1 && playHead == imageNumber)
			{
				// Set Playback Indicator to Reverse
				playbackIndicator.src = 'Images/indLive.png';

				forwardControl.style.opacity = 0;	// Make it invisible
			}
			else
			{
				forwardControl.style.opacity = 100;	// Make it visible
			}

			pauseControl.style.opacity = 100;		// Make it visible
			pauseControl.style.zIndex = 20;			// Put it above play control
			playControl.style.opacity = 0;			// Make it invisible
		}
	}
	else
	{
		playbackIndicator.src = 'Images/indStop.png';
	}
}


// startPlayMode - Starts normal refreshing
function startPlayMode ()
{
	playMode = 1;
	refreshTimer(true);
	showPlabackControls();
}


// stopPlayMode - Stops refreshing of the image
function stopPlayMode ()
{
	playMode = 0;
	refreshTimer(false);
	showPlabackControls();
}


// reversePlayMode - Steps backwards or reverses play mode.
function reversePlayMode ()
{
	if (playMode == 0)
	{
		if (playHead > 0)
		{
			playHead -= 1;			// Step back through the cache
			refreshImage();
			showPlabackControls();
		}
	}
	else
	{
		if (playMode == -1)			// Already reversing, jump to beginning
		{
			playHead = 0;
			refreshImage();
		}

		playMode = -1;				// Reverse play mode
		showPlabackControls();
	}
}


// forwardPlayMode - Steps forward or jumps to live play mode.
function forwardPlayMode ()
{
	if (playMode == 0)
	{
		if (playHead < imageNumber)
		{
			playHead += 1;				// Step forward through the cache
			refreshImage();
			showPlabackControls();
		}
	}
	else
	{
		if (playMode == 1)			// Already playing, jump to end
		{
			playHead = imageNumber;		// Jump to live play back
			refreshImage();
		}

		playMode = 1;
		showPlabackControls();
	}
}


// refreshImage - Updates the image
function refreshImage ()
{
	if (intRefresh > 0 && !bOnBack && picturesrc && picturesrc.length > 0)
	{
		playHead += playMode;

		// Handle rewind to beginning
		if (playHead <= 0 && playMode <= 0)
		{
			playHead = 0;
			playMode = 0;				// Pause
			showPlabackControls();		// Show the controls to signify paused
		}

		// Refresh the Image
		document.getElementById("picture").src = picturesrc + "?" + playHead;

		// Sync Play Head and Image Number
		if (playHead > imageNumber)
			imageNumber = playHead;
	}
}


// refreshTimer - starts the timer for refreshing the image
function refreshTimer(startTimer)
{
	clearInterval( timerInterval );

	if (startTimer && (intRefresh > 0))
	{
		timerInterval = setInterval("refreshImage();", intRefresh * 1000);
	}
}

// changeRefresh is called by the Refresh popup when its value is changed.  This function
// changes the refresh invterval of which to refresh the picture
function changeRefresh (elem)
{	
	intRefresh = parseInt(elem.options[elem.selectedIndex].value);

	// once the refresh interval is changed, it is saved as a preference
	if(window.widget)
	{
		widget.setPreferenceForKey(intRefresh,makeKey("refreshInt"));
	}
} 


//	setAutoMinimize - Sets the Auto Minimize property based on the prefernce control
function setAutoMinimize ()
{
	var	checkbox = document.getElementById("autoMinimizeCheckbox");

	bAutoMinimize = checkbox.checked;

    if (window.widget)
    {
		widget.setPreferenceForKey(checkbox.checked, makeKey("autoMinimize"));
    }
}


//	setAutoMaximize - Sets the Auto Maximize property based on the prefernce control
function setAutoMaximize ()
{
	var	checkbox = document.getElementById("autoMaximizeCheckbox");

	bAutoMaximize = checkbox.checked;

    if (window.widget)
    {
		widget.setPreferenceForKey(checkbox.checked, makeKey("autoMaximize"));
    }
}


//	setMaintainProportion - Sets the Maintain Proportion property based on the prefernce control
function setMaintainProportion ()
{
	var	checkbox = document.getElementById("maintainProportionCheckbox");

	bMaintainProportion = checkbox.checked;

    if (window.widget)
    {
		widget.setPreferenceForKey(checkbox.checked, makeKey("maintainProportion"));
    }
}


//	startAutoMinimize - Triggers the Auto Minimizing
function startAutoMinimize ()
{
	if (bAutoMinimize || bAutoMaximize || bMaximized)
	{
		bMinimize = true;
		setTimeout("doAutoMinimize()", delayAutoMinimize);			// Do this after a delay
	}
}


//	doAutoMinimize - Automatically minimizes the window

function doAutoMinimize ()
{
	if (!isMinMax() && bMinimize && bAutoMinimize && !bMaximized)
	{
		setMinMaxSemaphore();

		bMinimize = false;

		// Two AppleRect objects store the starting and finshing rectangle sizes
		var startingRect = new AppleRect (0, 0, document.getElementById("picture").width, document.getElementById("picture").height);
		var finishingRect = new AppleRect (0, 0, 25, 25);
		
		// The RectAnimation specifies the range of values and the handler to call at the animator's interval
		var currentRectAnimation = new AppleRectAnimation( startingRect, finishingRect, rectHandler);
	
		// The Animator is the timer for the animation
		var currentAnimator = new AppleAnimator (500, 13);
		
		// Associate the animator and animation
		currentAnimator.addAnimation(currentRectAnimation);
		
		// Set a handler to be called when the animation is done (in this case, flip the widget to its back)
		currentAnimator.oncomplete = clearMinMaxSemaphore;
	
		// Once everything is set up, start the animation
		currentAnimator.start();
	}
	else
	{
		if (bMinimize)
			undoAutoMaximize();
	}
}

function undoAutoMinimize ()
{
	if (!isMinMax() && bAutoMinimize && !bMinimize)
	{
		setMinMaxSemaphore();

		// Two AppleRect objects store the starting and finshing rectangle sizes
		var startingRect = new AppleRect (0, 0, gWidth, gHeight);
		var finishingRect = new AppleRect (0, 0, document.getElementById("picture").width+52, document.getElementById("picture").height+52);
	
		// The RectAnimation specifies the range of values and the handler to call at the animator's interval
		var currentRectAnimation = new AppleRectAnimation( startingRect, finishingRect, rectHandler);
	
		// The Animator is the timer for the animation
		var currentAnimator = new AppleAnimator (500, 13);
		
		// Associate the animator and animation
		currentAnimator.addAnimation(currentRectAnimation);
		
		// Set a handler to be called when the animation is done (in this case, flip the widget to its back)
		currentAnimator.oncomplete = clearMinMaxSemaphore;
	
		// Once everything is set up, start the animation
		currentAnimator.start();
	}
}


function doAutoMaximize ()
{
	if (!isMinMax() && bAutoMaximize && !bMaximized)
	{
		setMinMaxSemaphore();

		bMaximized = true;

		var targetWidth; 
		var	targetHeight;

		if (bResized)
		{
			targetWidth = document.getElementById("hiddenPic").width;
			targetHeight = document.getElementById("hiddenPic").height ;
		}
		else
		{
			targetWidth = (document.getElementById("hiddenPic").width) * 2;
			targetHeight = (document.getElementById("hiddenPic").height) * 2;
		}

		// Two AppleRect objects store the starting and finshing rectangle sizes
		var startingRect = new AppleRect (0, 0, gWidth - 52, gHeight - 52);
		var finishingRect = new AppleRect (0, 0, targetWidth, targetHeight);

		// The RectAnimation specifies the range of values and the handler to call at the animator's interval
		var currentRectAnimation = new AppleRectAnimation( startingRect, finishingRect, rectHandler2 );

		// The Animator is the timer for the animation
		var currentAnimator = new AppleAnimator (2000, 50);

		// Associate the animator and animation
		currentAnimator.addAnimation(currentRectAnimation);

		// Set a handler to be called when the animation is done (in this case, flip the widget to its back)
		currentAnimator.oncomplete = clearMinMaxSemaphore;
	
		// Once everything is set up, start the animation
		currentAnimator.start();
	}
}


function undoAutoMaximize ()
{
//	if (!isMinMax() && bAutoMaximize && bMaximized)
	if (!isMinMax() && bMaximized)
	{
		setMinMaxSemaphore();

		bMaximized = false;

		var targetWidth; 
		var	targetHeight;

		if (bResized)
		{
			targetWidth = widget.preferenceForKey(makeKey("customWidth"));
			targetHeight = widget.preferenceForKey(makeKey("customHeight"));
		}
		else
		{
			targetWidth = document.getElementById("hiddenPic").width;
			targetHeight = document.getElementById("hiddenPic").height;
		}

		// Two AppleRect objects store the starting and finshing rectangle sizes
		var startingRect = new AppleRect (0, 0, gWidth - 52, gHeight - 52);
		var finishingRect = new AppleRect (0, 0, targetWidth, targetHeight);

		// The RectAnimation specifies the range of values and the handler to call at the animator's interval
		var currentRectAnimation = new AppleRectAnimation( startingRect, finishingRect, rectHandler2 );

		// The Animator is the timer for the animation
		var currentAnimator = new AppleAnimator (2000, 50);

		// Associate the animator and animation
		currentAnimator.addAnimation(currentRectAnimation);

		// Set a handler to be called when the animation is done (in this case, flip the widget to its back)
		currentAnimator.oncomplete = clearMinMaxSemaphore;
	
		// Once everything is set up, start the animation
		currentAnimator.start();
	}
}


//	setMinMaxSemaphore - Sets the semaphore for mutually exclusive animated resizes
function setMinMaxSemaphore ()
{
	bMinMaxSemaphore = true;
}


//	clearMinMaxSemaphore - Sets the semaphore for mutually exclusive animated resizes
function clearMinMaxSemaphore ()
{
	bMinMaxSemaphore = false;
}


//	isMinMax - Is a Min or Max in progress
function isMinMax ()
{
	return bMinMaxSemaphore;
}


// onremove clears away any preferences that this widget may have had.
function onremove()
{
	if(window.widget)
	{
		widget.setPreferenceForKey(null,makeKey("image"));

		widget.setPreferenceForKey(null,makeKey("frameColor"));

		widget.setPreferenceForKey(null,makeKey("matColor"));

		widget.setPreferenceForKey(null,makeKey("refreshInt"));

		widget.setPreferenceForKey(null, makeKey("autoMinimize"));

		widget.setPreferenceForKey(null, makeKey("autoMaximize"));

		widget.setPreferenceForKey(null, makeKey("maintainProportion"));

		clearCustomImageSize();
	}
}

// onshow starts the image refreshing
function onshow()
{
	refreshImage();

	refreshTimer(true);
}

// onhide stops the image refreshing
function onhide()
{
	refreshTimer(false);

	startAutoMinimize();
}

// this is where widget-specific handlers can be declared.

if(window.widget)
{
	widget.onremove = onremove;
}

if(window.widget)
{
	widget.onshow = onshow;
}

if(window.widget)
{
	widget.onhide = onhide;
}
