// Standard widget resize code follows...

var growboxInset;
var gResizeX;
var gResizeY;

function resizeMouseDown(event)
{
 	bResizing = true;
 	bResized = false;
 
 	// Stop Auto Minimizing
 	bAutoMinimize = false;
 
    document.addEventListener("mousemove", resizeMouseMove, true);
    document.addEventListener("mouseup", resizeMouseUp, true);
 
//    growboxInset = {x:(window.innerWidth - event.x), y:(window.innerHeight - event.y)};
	growboxInset = {x:(document.getElementById("picture").width - event.x), y:(document.getElementById("picture").height - event.y)};
 
    event.stopPropagation();
    event.preventDefault();
}
 
function resizeMouseMove(event)
{
	// checks if the reported event data is legit or not
	if((event.x == -1 ) || (event.y == -1 )) { break; }
	
	gResizeX = event.x + growboxInset.x;
    gResizeY = event.y + growboxInset.y;

	if (bMaintainProportion)
	{
		constrainProportion();
	}

	imageResize(gResizeX, gResizeY);
	bResized = true;

    event.stopPropagation();
    event.preventDefault();
}

function resizeMouseUp(event)
{
	bResizing = false;

    document.removeEventListener("mousemove", resizeMouseMove, true);
    document.removeEventListener("mouseup", resizeMouseUp, true); 

	if (bResized)
	{
		setCustomImageSize();
	}
	else
	{
		clearCustomImageSize();
		preResize();
	}

	// Resync Auto Minimze Setting
	setTimeout ('setAutoMinimize();', delayAutoMinimize);

    event.stopPropagation();
    event.preventDefault();
}


//	constrainProportion - Constrains the resizing to maintain its original proportions

function constrainProportion ()
{
	// Get original size
	var oldX = document.getElementById("hiddenPic").width;
	var oldY = document.getElementById("hiddenPic").height;

	if (oldY > oldX)
	{
		if (gResizeY > gMaxHeight)
			gResizeY = gMaxHeight;

		gResizeX = gResizeY * (oldX / oldY);

		if (gResizeX < 200)
		{
			gResizeX = 200;
			gResizeY = gResizeX * (oldY / oldX);
		}
	}
	else
	{
		if (gResizeX > gMaxWidth)
			gResizeX = gMaxWidth;

		gResizeY = gResizeX * (oldY / oldX);

		if (gResizeY < 200)
		{
			gResizeY = 200;
			gResizeX = gResizeY * (oldX / oldY);
		}
	}
}
